<template>
    <div
        v-if="shop"
        class="push-preview-container"
    >
        <div class="push-notification-container">
            <div class="notification-img">
                <img
                    class="push-preview-image"
                    src="/images/product-img-thumb.png"
                    alt=""
                >
            </div>
            <div class="push-notification-content">
                <div class="title">
                    <strong v-html="replaceText(pushPreview.title)" />
                </div>
                <p
                    class="subtitle"
                    v-html="replaceText(pushPreview.text)"
                />
                <a
                    href="#"
                    class="carti-link"
                >{{ shop.site_url }}</a>
            </div>
        </div>
    </div>
</template>

<script>
import shop from '../../../mixins/shop.service'

export default {
    name: "PushPreview",
    mixins: [shop],
    props: ['pushPreview'],
    data() {
        return {
            shop: null,
            code: Math.random().toString(36).slice(2, 8).toUpperCase(),
        }
    },
    created() {
        this.loadShop()
    },
    methods: {
        async loadShop() {
            this.shop = await this.getShop()
        },
        replaceText(text) {
            text = text.replace(/{domain}/g, '<a href="#">' + (this.shop.site_url ? this.shop.site_url: 'Shop URL') + '</a>');
            text = text.replace(/{firstName}/g, 'John');
            text = text.replace(/{lastName}/g, 'Doe');
            text = text.replace(/{siteName}/g, this.shop.custom_name || this.shop.site_name);
            text = text.replace(/{cartLink}/g, '<a href="#">' + 'Cart URL' + '</a>');
            text = text.replace(/{\/cartLink}/g, '</a>');
            text = text.replace(/{unsubscribeLink}/g, '<a href="#">');
            text = text.replace(/{\/unsubscribeLink}/g, '</a>');
            text = text.replace(/{discountValue}/g, this.pushPreview.automatic_discount_value);
            text = text.replace(/{discountCode}/g, this.pushPreview.automatic_discount_enabled == false ? this.pushPreview.code : this.code);
            text = text.replace(/{storeEmail}/g,  this.shop.custom_email || this.shop.email || 'Email');
            return text;
        }
    }

}
</script>

<style scoped lang="scss">

.push-preview-image {
    width: 68px;
    height: auto;
}

.carti-link {
    color: #888888;
    text-decoration: none;
    font-size: 12px;
}

.push-preview-container {
    display: flex;
    justify-content: center;
    margin-top: 45px;
    @media(max-width: 1200px) {
        margin-top: 0;
    }
}

.push-notification-content {
    display: flex;
    flex-direction: column;
    padding-left: 15px;
    position: relative;
     p {
         font-size: 12px;
         margin: 0;
     }
}

.push-notification-container {
    display: flex;
    width: 100%;
    max-width: 360px;
    border: 1px solid #f0f0f0;
    padding: 10px;
    box-shadow: 0 3px 3px rgb(0 0 0 / 20%);
    background: #ffffff;
}

.notification-img {
    display: flex;
    align-items: flex-start;
    width: 85px;
    height: 85px;
    justify-content: center;
}

</style>
